
%%

%public
%class ProofObligationExtractor

%line
%char
%full

%unicode


%eof{

	impl.eof();
%eof}	

%{

private ProofObligationExtractorLogic impl = 
	new ProofObligationExtractorLogic();


/**
   * Runs the scanner on input files.
   *
   * This is a standalone scanner, it will print any unmatched
   * text to System.out unchanged.
   *
   * @param argv   the command line, contains the filenames to run
   *               the scanner on.
   */
  public static void main(String argv[]) {
    if (argv.length == 0) {
      System.out.println("Usage : java ProofObligationExtractor <inputfile>");
    }
    else {
      for (int i = 0; i < argv.length; i++) {
        ProofObligationExtractor scanner = null;
        try {
          scanner = new ProofObligationExtractor( new java.io.FileReader(argv[i]), argv[i]);
          while ( !scanner.zzAtEOF ) scanner.yylex();
        }
        catch (java.io.FileNotFoundException e) {
          System.out.println("File not found : \""+argv[i]+"\"");
        }
        catch (java.io.IOException e) {
          System.out.println("IO error scanning file \""+argv[i]+"\"");
          System.out.println(e);
        }
        catch (Exception e) {
          System.out.println("Unexpected exception:");
          e.printStackTrace();
        }
      }
    }
  }

  /**
   * Creates a new scanner
   * There is also a java.io.InputStream version of this constructor.
   *
   * @param   in  the java.io.Reader to read input from.
   */
  public ProofObligationExtractor(java.io.Reader in, String fileName) {
    this.zzReader = in;
	impl.setFileName(fileName);
  }

  /**
   * Creates a new scanner.
   * There is also java.io.Reader version of this constructor.
   *
   * @param   in  the java.io.Inputstream to read input from.
   */
  public ProofObligationExtractor(java.io.InputStream in, String fileName) {
    this(new java.io.InputStreamReader(in), fileName);
  }



%}

%state INPO
/*
 * INPO state is reached when the next lines will be part of a 
 * Proof Obligation
 */


NEWLINE = [\n\r]+
LINE = [^\n]*\n

%%

<YYINITIAL>{LINE}	{

	boolean isSeparator = impl.yyinitialLINE(yytext());
	
	if(isSeparator) {
		yybegin(INPO);
	}
}

<INPO>{NEWLINE}	{
	
	// here ends the Proof Obligation

	try {
		impl.inpoNEWLINE();
	} catch(java.lang.Exception e) {
		e.printStackTrace();

		return null;
	}

	// leave Proof Obligation state
	yybegin(YYINITIAL);
}

<INPO>{LINE}	{
	
	// got a Proof Obligation line
	impl.inpoLINE(yytext());
}


