import java.lang.String;

/**
 * Represents a Proof Obligation.
 *
 * @author Miguel Ferreira <b>miguel@di.uminho.pt</b>
 * @author Samuel Silva <b>silva.samuel@gmail.com</b>
 * @version 1.0
 */
public class ProofObligation {

		private ProofObligationType type = null;
		private String expression = null;

		/**
		 * Contructor.
		 *
		 * @param type       the type (or classification) of the Proof Obligation.
		 * @param expression the Proof Obligation expression.
		 */
		public ProofObligation(ProofObligationType type, String expression) {
		
				this.type = type;
				this.expression = expression;
		}

		/**
		 * Get the Proof Obligation's type.
		 *
		 * @return the type (or classification).
		 */
		public ProofObligationType getType() { return type; }

		/**
	 	 * Get the Proof Obligation's expression.
	 	 *
	 	 * @return the expression.
	 	 */
		public String getExpression() { return expression; }
}
